import { Component, Inject } from '@angular/core';
import { MatSnackBarRef, MAT_SNACK_BAR_DATA } from '@angular/material/snack-bar';
import { AlertType } from '../alert-type.enum';

export class NotificationAlert {
  message: string;
  type: AlertType;

  constructor(message: string, type: AlertType) {
    this.message = message;
    this.type = type;
  }
}

@Component({
  selector: 'app-notification',
  templateUrl: './notification.component.html',
  styleUrls: ['./notification.component.css']
})
export class NotificationComponent {

  alerts: NotificationAlert[] = [];

  constructor(public snackBarRef: MatSnackBarRef<NotificationComponent>,
              @Inject(MAT_SNACK_BAR_DATA) public data: any) {
      this.alerts = this.data.alerts;
  }

  removeAlert(alert: NotificationAlert) {
    this.alerts.splice(this.alerts.indexOf(alert), 1);
    if (this.alerts.length === 0) {
        this.snackBarRef.dismiss();
    }
  }
  
}
