import { ChangeDetectorRef, Component, Inject, OnDestroy, OnInit } from '@angular/core';
import { Subscription } from 'rxjs/internal/Subscription';
import { LoadingService } from './services/loading.service';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent  implements OnInit, OnDestroy {

  private subscriptions: Subscription[] = [];
  public loading: boolean = false;
  title = 'FAUdok';

  constructor(
    private loadingService: LoadingService, 
    private changeDetectionRef: ChangeDetectorRef,
  ) {
  }

  //init global loading
  ngOnInit() {
    this.subscriptions.push(
      this.loadingService.isLoading.subscribe(loading => {
        this.loading = loading;
        this.changeDetectionRef.detectChanges();
      })
    );
  }


  ngOnDestroy() {
    this.subscriptions.forEach(sub => sub.unsubscribe());
  }
}
