// import { AfterViewInit, ChangeDetectorRef, Component, OnDestroy, OnInit, ViewChild } from '@angular/core';
// import { MatPaginator } from '@angular/material/paginator';
// import { MatTableDataSource } from '@angular/material/table';
// import { saveAs } from 'file-saver';
// import * as Papa from 'papaparse';
// import { catchError, map, merge, Observable, of, startWith, Subscription, switchMap } from 'rxjs';
// import { AlertService } from 'src/app/services/alert.service';
// import { LoadingService } from 'src/app/services/loading.service';
// import { FilterArchivedOrders$Params } from 'src/openapi/generated/fn/admin-order/filter-archived-orders';
// import { OrderResponseDto } from 'src/openapi/generated/models';
// import { AdminOrderService } from 'src/openapi/generated/services';


// @Component({
//   selector: 'app-statistics',
//   templateUrl: './statistics.component.html',
//   styleUrls: ['./statistics.component.css']
// })
// export class StatisticsComponent implements OnDestroy, AfterViewInit {

//   faculties: string[] =  ['HB', 'TNZB', 'WSZB', 'EZB', 'JURA', 'NBG_FINDELGASSE', 'HB_DOD_SCAN_ZIMMER', 'SISIS_GRUPPE_TEST', 'TB_THEOLOGIE_KOCHSTRASSE', 'ERL_BISMARCKSTRASSE', "ALL"];
//   statuses: string[] = ['SCANNED', 'REJECTED', 'ALL'];
//   selectedFaculty: string = '';
//   selectedStatus: string = '';
//   selectedMonthStart: number = 0;  //defaults to 15 months ago
//   selectedMonthEnd: number = 14; // defaults to the current month of current year

//   displayedColumns: string[] = ['id', 'doneDate', 'clientDeliveryEmail', 'signature', 'authorArticle', 'authorBook', 'titleArticle', 'titleBook', 'bvNr', 'isbn', 'issn'];
//   data: MatTableDataSource<OrderResponseDto> ;
//   resultsLength = 0;
//   hasOrders: boolean = true;
//   @ViewChild(MatPaginator) paginator: MatPaginator;
//   subscriptions: Subscription[] = [];


//   constructor(
//     private loadingService: LoadingService,
//     private alertService: AlertService,
//     private adminOrderService: AdminOrderService,
//   ) {
//     this.subscriptions.push(
//       this.filterArchivedOrders().subscribe(data =>
//        {
//         data.totalElements !== 0 ? this.hasOrders = true : this.hasOrders = false;
//         this.resultsLength = data.totalElements;
//         this.data = new MatTableDataSource(data.content);
//        }
//       )
//     );
//   }

  
//   ngAfterViewInit() {
//     //if table is not created bec has no orders, skip checking pagination
//     if (this.paginator) {
//       this.paginator.pageIndex = 0;
//       // If the user changes the sort order, reset back to the first page.
//       this.subscriptions.push(
//         this.paginator.page
//           .pipe(
//             switchMap(() => {
//               this.loadingService.isLoading.next(true);
//               return this.filterArchivedOrders().pipe(catchError(() => of(null)));
//             }),
//             map(data => {
//               // Flip flag to show that loading has finished.
//               this.loadingService.isLoading.next(false);
//               if (data === null) {
//                 return [];
//               }
//               // Only refresh the result length if there is new data. 
//               this.resultsLength = data.totalElements;
//               return data.content;
//             }),
//           )
//           .subscribe(data => (this.data = new MatTableDataSource( data ) ))
//       );
//     }
//   }

//   private filterArchivedOrders() : Observable<any> {
//     let params: FilterArchivedOrders$Params = {
//       startDate: this.getDateFromSelection(this.selectedMonthStart),
//       endDate: this.getDateFromSelection(this.selectedMonthEnd),
//       sortBy: 'doneDate',
//       sortDir: 'desc',
//     };
//     if (this.selectedFaculty) {
//       params.faculty = this.selectedFaculty;
//     } 
//     if (this.selectedStatus) {
//       params.status = this.selectedStatus;
//     } 
//     if (this.paginator?.pageIndex) {
//       params.pageNo = this.paginator.pageIndex;
//     }
//     if (this.paginator?.pageSize) {
//       params.pageSize = this.paginator.pageSize;
//     }
//     return this.adminOrderService.filterArchivedOrders(params);
//   }

//   ngOnDestroy(): void {
//     this.subscriptions.forEach(sub => sub.unsubscribe());
//   }

//   // Get label for the selected month
//   getMonthLabel(value: number): string {
//     if(value > 14 || value < 0) {
//       return '';
//     }
//     const today = new Date();
//     const selectedDate = new Date(today.getFullYear(), today.getMonth() - (14 - value), 1);
//     return `${selectedDate.toLocaleString('default', { month: 'long' })} ${selectedDate.getFullYear()}`;
//   }

//   getDateFromSelection(value: number): string {
//     if(value > 14 || value < 0) {
//       throw new Error('Invalid month selected');
//     }
//     const today = new Date();
//     return new Date(today.getFullYear(), today.getMonth() - (14 - value), 1).toDateString();
//   }

//   // Handle changes in the date interval / faculty / status
//   filterResults() {
//     if(this.data.paginator) {
//       this.data.paginator.firstPage();
//     }
//     // Apply filtering based on the selected month, faculty, and status
//     this.filterArchivedOrders().subscribe(data => {
//       data.totalElements !== 0 ? this.hasOrders = true : this.hasOrders = false;
//       this.resultsLength = data.totalElements;
//       this.data = new MatTableDataSource(data.content);
//     });
//   }

//   // Export filtered orders as CSV
//   exportToCSV() {
//     const csv = Papa.unparse(this.data);
//     const blob = new Blob([csv], { type: 'text/csv;charset=utf-8;' });
//     saveAs(blob, 'orders.csv');
//   }

// }
