import { Component, Inject } from '@angular/core';
import { MAT_DIALOG_DATA, MatDialogRef } from '@angular/material/dialog';

@Component({
  selector: 'app-confirmation-dialog',
  templateUrl: './confirmation-dialog.component.html',
  styleUrls: ['./confirmation-dialog.component.css']
})
export class ConfirmationDialogComponent {

  constructor(
    public dialogRef: MatDialogRef<ConfirmationDialogComponent>,
    @Inject(MAT_DIALOG_DATA) public data: { message: string }
  ) {
    if(!data) {
      this.data = { message: 'Are you sure you want to proceed?' };
    }
   }

  onConfirm(): void {
    this.dialogRef.close(true);   
  }

  onDismiss(): void {
    this.dialogRef.close(false);
  }
}
