import { Injectable } from '@angular/core';
import { CanDeactivate } from '@angular/router';
import { MatDialog } from '@angular/material/dialog';
import { Observable } from 'rxjs';
import { ConfirmationDialogComponent } from '../confirmation-dialog/confirmation-dialog.component';

export interface CanComponentDeactivate {
  canDeactivate: () => boolean | Observable<boolean>;
}

@Injectable({
  providedIn: 'root',
})
export class ConfirmLeaveGuard implements CanDeactivate<CanComponentDeactivate> {

  constructor() {}

  canDeactivate(component: CanComponentDeactivate): Observable<boolean> | boolean {
      
     return component.canDeactivate ? component.canDeactivate() : true;
  }
}