/* tslint:disable */
/* eslint-disable */
import { HttpClient, HttpContext, HttpResponse } from '@angular/common/http';
import { Observable } from 'rxjs';
import { filter, map } from 'rxjs/operators';
import { StrictHttpResponse } from '../../strict-http-response';
import { RequestBuilder } from '../../request-builder';


export interface GetOrderPdf$Params {
  orderId: string;
  obsolete?: boolean;
}

export function getOrderPdf(http: HttpClient, rootUrl: string, params: GetOrderPdf$Params, context?: HttpContext): Observable<StrictHttpResponse<Blob>> {
  const rb = new RequestBuilder(rootUrl, getOrderPdf.PATH, 'get');
  if (params) {
    rb.path('orderId', params.orderId, {});
    rb.query('obsolete', params.obsolete, {});
  }

  return http.request(
    rb.build({ responseType: 'blob', accept: 'application/json', context })
  ).pipe(
    filter((r: any): r is HttpResponse<any> => r instanceof HttpResponse),
    map((r: HttpResponse<any>) => {
      return r as StrictHttpResponse<Blob>;
    })
  );
}

getOrderPdf.PATH = '/v1/orders/pdf/{orderId}';
