/* tslint:disable */
/* eslint-disable */
import { HttpClient, HttpContext, HttpResponse } from '@angular/common/http';
import { Observable } from 'rxjs';
import { filter, map } from 'rxjs/operators';
import { StrictHttpResponse } from '../../strict-http-response';
import { RequestBuilder } from '../../request-builder';

import { OrderRequestDto } from '../../models/order-request-dto';
import { OrderResponseDto } from '../../models/order-response-dto';

export interface UpdateOrderData$Params {
  orderId: string;
  body: OrderRequestDto
}

export function updateOrderData(http: HttpClient, rootUrl: string, params: UpdateOrderData$Params, context?: HttpContext): Observable<StrictHttpResponse<OrderResponseDto>> {
  const rb = new RequestBuilder(rootUrl, updateOrderData.PATH, 'patch');
  if (params) {
    rb.path('orderId', params.orderId, {});
    rb.body(params.body, 'application/json');
  }

  return http.request(
    rb.build({ responseType: 'json', accept: 'application/json', context })
  ).pipe(
    filter((r: any): r is HttpResponse<any> => r instanceof HttpResponse),
    map((r: HttpResponse<any>) => {
      return r as StrictHttpResponse<OrderResponseDto>;
    })
  );
}

updateOrderData.PATH = '/v1/orders/update/{orderId}';
