/* tslint:disable */
/* eslint-disable */
import { HttpClient, HttpContext } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { map } from 'rxjs/operators';

import { BaseService } from '../base-service';
import { ApiConfiguration } from '../api-configuration';
import { StrictHttpResponse } from '../strict-http-response';

import { FaudokResponsePageOrderResponseDto } from '../models/faudok-response-page-order-response-dto';
import { filterArchivedOrders } from '../fn/admin-order/filter-archived-orders';
import { FilterArchivedOrders$Params } from '../fn/admin-order/filter-archived-orders';
import { getAllArchivedOrders } from '../fn/admin-order/get-all-archived-orders';
import { GetAllArchivedOrders$Params } from '../fn/admin-order/get-all-archived-orders';
import { getAllAvailableOrders } from '../fn/admin-order/get-all-available-orders';
import { GetAllAvailableOrders$Params } from '../fn/admin-order/get-all-available-orders';
import { getAllInprogressOrders } from '../fn/admin-order/get-all-inprogress-orders';
import { GetAllInprogressOrders$Params } from '../fn/admin-order/get-all-inprogress-orders';
import { getAnyOrderByIdContaining } from '../fn/admin-order/get-any-order-by-id-containing';
import { GetAnyOrderByIdContaining$Params } from '../fn/admin-order/get-any-order-by-id-containing';
import { getAnyOrderBySignatureContaining } from '../fn/admin-order/get-any-order-by-signature-containing';
import { GetAnyOrderBySignatureContaining$Params } from '../fn/admin-order/get-any-order-by-signature-containing';
import { getAnyOrdersByClientEmailContaining } from '../fn/admin-order/get-any-orders-by-client-email-containing';
import { GetAnyOrdersByClientEmailContaining$Params } from '../fn/admin-order/get-any-orders-by-client-email-containing';
import { moveOrder } from '../fn/admin-order/move-order';
import { MoveOrder$Params } from '../fn/admin-order/move-order';

@Injectable({ providedIn: 'root' })
export class AdminOrderService extends BaseService {
  constructor(config: ApiConfiguration, http: HttpClient) {
    super(config, http);
  }

  /** Path part for operation `moveOrder()` */
  static readonly MoveOrderPath = '/v1/management/orders/move/{id}';

  /**
   * This method provides access to the full `HttpResponse`, allowing access to response headers.
   * To access only the response body, use `moveOrder()` instead.
   *
   * This method doesn't expect any request body.
   */
  moveOrder$Response(params: MoveOrder$Params, context?: HttpContext): Observable<StrictHttpResponse<void>> {
    return moveOrder(this.http, this.rootUrl, params, context);
  }

  /**
   * This method provides access only to the response body.
   * To access the full response (for headers, for example), `moveOrder$Response()` instead.
   *
   * This method doesn't expect any request body.
   */
  moveOrder(params: MoveOrder$Params, context?: HttpContext): Observable<void> {
    return this.moveOrder$Response(params, context).pipe(
      map((r: StrictHttpResponse<void>): void => r.body)
    );
  }

  /** Path part for operation `filterArchivedOrders()` */
  static readonly FilterArchivedOrdersPath = '/v1/management/orders/statistics';

  /**
   * This method provides access to the full `HttpResponse`, allowing access to response headers.
   * To access only the response body, use `filterArchivedOrders()` instead.
   *
   * This method doesn't expect any request body.
   */
  filterArchivedOrders$Response(params?: FilterArchivedOrders$Params, context?: HttpContext): Observable<StrictHttpResponse<FaudokResponsePageOrderResponseDto>> {
    return filterArchivedOrders(this.http, this.rootUrl, params, context);
  }

  /**
   * This method provides access only to the response body.
   * To access the full response (for headers, for example), `filterArchivedOrders$Response()` instead.
   *
   * This method doesn't expect any request body.
   */
  filterArchivedOrders(params?: FilterArchivedOrders$Params, context?: HttpContext): Observable<FaudokResponsePageOrderResponseDto> {
    return this.filterArchivedOrders$Response(params, context).pipe(
      map((r: StrictHttpResponse<FaudokResponsePageOrderResponseDto>): FaudokResponsePageOrderResponseDto => r.body)
    );
  }

  /** Path part for operation `getAnyOrderBySignatureContaining()` */
  static readonly GetAnyOrderBySignatureContainingPath = '/v1/management/orders/signature';

  /**
   * This method provides access to the full `HttpResponse`, allowing access to response headers.
   * To access only the response body, use `getAnyOrderBySignatureContaining()` instead.
   *
   * This method doesn't expect any request body.
   */
  getAnyOrderBySignatureContaining$Response(params: GetAnyOrderBySignatureContaining$Params, context?: HttpContext): Observable<StrictHttpResponse<FaudokResponsePageOrderResponseDto>> {
    return getAnyOrderBySignatureContaining(this.http, this.rootUrl, params, context);
  }

  /**
   * This method provides access only to the response body.
   * To access the full response (for headers, for example), `getAnyOrderBySignatureContaining$Response()` instead.
   *
   * This method doesn't expect any request body.
   */
  getAnyOrderBySignatureContaining(params: GetAnyOrderBySignatureContaining$Params, context?: HttpContext): Observable<FaudokResponsePageOrderResponseDto> {
    return this.getAnyOrderBySignatureContaining$Response(params, context).pipe(
      map((r: StrictHttpResponse<FaudokResponsePageOrderResponseDto>): FaudokResponsePageOrderResponseDto => r.body)
    );
  }

  /** Path part for operation `getAllInprogressOrders()` */
  static readonly GetAllInprogressOrdersPath = '/v1/management/orders/inprogress';

  /**
   * This method provides access to the full `HttpResponse`, allowing access to response headers.
   * To access only the response body, use `getAllInprogressOrders()` instead.
   *
   * This method doesn't expect any request body.
   */
  getAllInprogressOrders$Response(params?: GetAllInprogressOrders$Params, context?: HttpContext): Observable<StrictHttpResponse<FaudokResponsePageOrderResponseDto>> {
    return getAllInprogressOrders(this.http, this.rootUrl, params, context);
  }

  /**
   * This method provides access only to the response body.
   * To access the full response (for headers, for example), `getAllInprogressOrders$Response()` instead.
   *
   * This method doesn't expect any request body.
   */
  getAllInprogressOrders(params?: GetAllInprogressOrders$Params, context?: HttpContext): Observable<FaudokResponsePageOrderResponseDto> {
    return this.getAllInprogressOrders$Response(params, context).pipe(
      map((r: StrictHttpResponse<FaudokResponsePageOrderResponseDto>): FaudokResponsePageOrderResponseDto => r.body)
    );
  }

  /** Path part for operation `getAnyOrderByIdContaining()` */
  static readonly GetAnyOrderByIdContainingPath = '/v1/management/orders/id';

  /**
   * This method provides access to the full `HttpResponse`, allowing access to response headers.
   * To access only the response body, use `getAnyOrderByIdContaining()` instead.
   *
   * This method doesn't expect any request body.
   */
  getAnyOrderByIdContaining$Response(params: GetAnyOrderByIdContaining$Params, context?: HttpContext): Observable<StrictHttpResponse<FaudokResponsePageOrderResponseDto>> {
    return getAnyOrderByIdContaining(this.http, this.rootUrl, params, context);
  }

  /**
   * This method provides access only to the response body.
   * To access the full response (for headers, for example), `getAnyOrderByIdContaining$Response()` instead.
   *
   * This method doesn't expect any request body.
   */
  getAnyOrderByIdContaining(params: GetAnyOrderByIdContaining$Params, context?: HttpContext): Observable<FaudokResponsePageOrderResponseDto> {
    return this.getAnyOrderByIdContaining$Response(params, context).pipe(
      map((r: StrictHttpResponse<FaudokResponsePageOrderResponseDto>): FaudokResponsePageOrderResponseDto => r.body)
    );
  }

  /** Path part for operation `getAnyOrdersByClientEmailContaining()` */
  static readonly GetAnyOrdersByClientEmailContainingPath = '/v1/management/orders/email';

  /**
   * This method provides access to the full `HttpResponse`, allowing access to response headers.
   * To access only the response body, use `getAnyOrdersByClientEmailContaining()` instead.
   *
   * This method doesn't expect any request body.
   */
  getAnyOrdersByClientEmailContaining$Response(params: GetAnyOrdersByClientEmailContaining$Params, context?: HttpContext): Observable<StrictHttpResponse<FaudokResponsePageOrderResponseDto>> {
    return getAnyOrdersByClientEmailContaining(this.http, this.rootUrl, params, context);
  }

  /**
   * This method provides access only to the response body.
   * To access the full response (for headers, for example), `getAnyOrdersByClientEmailContaining$Response()` instead.
   *
   * This method doesn't expect any request body.
   */
  getAnyOrdersByClientEmailContaining(params: GetAnyOrdersByClientEmailContaining$Params, context?: HttpContext): Observable<FaudokResponsePageOrderResponseDto> {
    return this.getAnyOrdersByClientEmailContaining$Response(params, context).pipe(
      map((r: StrictHttpResponse<FaudokResponsePageOrderResponseDto>): FaudokResponsePageOrderResponseDto => r.body)
    );
  }

  /** Path part for operation `getAllAvailableOrders()` */
  static readonly GetAllAvailableOrdersPath = '/v1/management/orders/available';

  /**
   * This method provides access to the full `HttpResponse`, allowing access to response headers.
   * To access only the response body, use `getAllAvailableOrders()` instead.
   *
   * This method doesn't expect any request body.
   */
  getAllAvailableOrders$Response(params?: GetAllAvailableOrders$Params, context?: HttpContext): Observable<StrictHttpResponse<FaudokResponsePageOrderResponseDto>> {
    return getAllAvailableOrders(this.http, this.rootUrl, params, context);
  }

  /**
   * This method provides access only to the response body.
   * To access the full response (for headers, for example), `getAllAvailableOrders$Response()` instead.
   *
   * This method doesn't expect any request body.
   */
  getAllAvailableOrders(params?: GetAllAvailableOrders$Params, context?: HttpContext): Observable<FaudokResponsePageOrderResponseDto> {
    return this.getAllAvailableOrders$Response(params, context).pipe(
      map((r: StrictHttpResponse<FaudokResponsePageOrderResponseDto>): FaudokResponsePageOrderResponseDto => r.body)
    );
  }

  /** Path part for operation `getAllArchivedOrders()` */
  static readonly GetAllArchivedOrdersPath = '/v1/management/orders/archived';

  /**
   * This method provides access to the full `HttpResponse`, allowing access to response headers.
   * To access only the response body, use `getAllArchivedOrders()` instead.
   *
   * This method doesn't expect any request body.
   */
  getAllArchivedOrders$Response(params?: GetAllArchivedOrders$Params, context?: HttpContext): Observable<StrictHttpResponse<FaudokResponsePageOrderResponseDto>> {
    return getAllArchivedOrders(this.http, this.rootUrl, params, context);
  }

  /**
   * This method provides access only to the response body.
   * To access the full response (for headers, for example), `getAllArchivedOrders$Response()` instead.
   *
   * This method doesn't expect any request body.
   */
  getAllArchivedOrders(params?: GetAllArchivedOrders$Params, context?: HttpContext): Observable<FaudokResponsePageOrderResponseDto> {
    return this.getAllArchivedOrders$Response(params, context).pipe(
      map((r: StrictHttpResponse<FaudokResponsePageOrderResponseDto>): FaudokResponsePageOrderResponseDto => r.body)
    );
  }

}
