/* tslint:disable */
/* eslint-disable */
import { HttpClient, HttpContext } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { map } from 'rxjs/operators';

import { BaseService } from '../base-service';
import { ApiConfiguration } from '../api-configuration';
import { StrictHttpResponse } from '../strict-http-response';

import { downloadFile } from '../fn/order/download-file';
import { DownloadFile$Params } from '../fn/order/download-file';
import { FaudokResponsePageOrderResponseDto } from '../models/faudok-response-page-order-response-dto';
import { getChairsArchivedOrders } from '../fn/order/get-chairs-archived-orders';
import { GetChairsArchivedOrders$Params } from '../fn/order/get-chairs-archived-orders';
import { getChairsAvailableOrders } from '../fn/order/get-chairs-available-orders';
import { GetChairsAvailableOrders$Params } from '../fn/order/get-chairs-available-orders';
import { getChairsInprogressOrders } from '../fn/order/get-chairs-inprogress-orders';
import { GetChairsInprogressOrders$Params } from '../fn/order/get-chairs-inprogress-orders';
import { getChairsOrderByClientEmailContaining } from '../fn/order/get-chairs-order-by-client-email-containing';
import { GetChairsOrderByClientEmailContaining$Params } from '../fn/order/get-chairs-order-by-client-email-containing';
import { getChairsOrderByIdContaining } from '../fn/order/get-chairs-order-by-id-containing';
import { GetChairsOrderByIdContaining$Params } from '../fn/order/get-chairs-order-by-id-containing';
import { getChairsOrderBySignatureContaining } from '../fn/order/get-chairs-order-by-signature-containing';
import { GetChairsOrderBySignatureContaining$Params } from '../fn/order/get-chairs-order-by-signature-containing';
import { getOrderPdf } from '../fn/order/get-order-pdf';
import { GetOrderPdf$Params } from '../fn/order/get-order-pdf';
import { handleCancelRescanFile } from '../fn/order/handle-cancel-rescan-file';
import { HandleCancelRescanFile$Params } from '../fn/order/handle-cancel-rescan-file';
import { handlePostponeOrder } from '../fn/order/handle-postpone-order';
import { HandlePostponeOrder$Params } from '../fn/order/handle-postpone-order';
import { handleRejectOrder } from '../fn/order/handle-reject-order';
import { HandleRejectOrder$Params } from '../fn/order/handle-reject-order';
import { handleRescanFile } from '../fn/order/handle-rescan-file';
import { HandleRescanFile$Params } from '../fn/order/handle-rescan-file';
import { handleScanOrder } from '../fn/order/handle-scan-order';
import { HandleScanOrder$Params } from '../fn/order/handle-scan-order';
import { mergeOrderPdf } from '../fn/order/merge-order-pdf';
import { MergeOrderPdf$Params } from '../fn/order/merge-order-pdf';
import { OrderResponseDto } from '../models/order-response-dto';
import { resendEmailLinkPdf } from '../fn/order/resend-email-link-pdf';
import { ResendEmailLinkPdf$Params } from '../fn/order/resend-email-link-pdf';
import { updateOrderData } from '../fn/order/update-order-data';
import { UpdateOrderData$Params } from '../fn/order/update-order-data';

@Injectable({ providedIn: 'root' })
export class OrderService extends BaseService {
  constructor(config: ApiConfiguration, http: HttpClient) {
    super(config, http);
  }

  /** Path part for operation `mergeOrderPdf()` */
  static readonly MergeOrderPdfPath = '/v1/orders/pdf/upload';

  /**
   * This method provides access to the full `HttpResponse`, allowing access to response headers.
   * To access only the response body, use `mergeOrderPdf()` instead.
   *
   * This method sends `multipart/form-data` and handles request body of type `multipart/form-data`.
   */
  mergeOrderPdf$Response(params?: MergeOrderPdf$Params, context?: HttpContext): Observable<StrictHttpResponse<{
}>> {
    return mergeOrderPdf(this.http, this.rootUrl, params, context);
  }

  /**
   * This method provides access only to the response body.
   * To access the full response (for headers, for example), `mergeOrderPdf$Response()` instead.
   *
   * This method sends `multipart/form-data` and handles request body of type `multipart/form-data`.
   */
  mergeOrderPdf(params?: MergeOrderPdf$Params, context?: HttpContext): Observable<{
}> {
    return this.mergeOrderPdf$Response(params, context).pipe(
      map((r: StrictHttpResponse<{
}>): {
} => r.body)
    );
  }

  /** Path part for operation `updateOrderData()` */
  static readonly UpdateOrderDataPath = '/v1/orders/update/{orderId}';

  /**
   * This method provides access to the full `HttpResponse`, allowing access to response headers.
   * To access only the response body, use `updateOrderData()` instead.
   *
   * This method sends `application/json` and handles request body of type `application/json`.
   */
  updateOrderData$Response(params: UpdateOrderData$Params, context?: HttpContext): Observable<StrictHttpResponse<OrderResponseDto>> {
    return updateOrderData(this.http, this.rootUrl, params, context);
  }

  /**
   * This method provides access only to the response body.
   * To access the full response (for headers, for example), `updateOrderData$Response()` instead.
   *
   * This method sends `application/json` and handles request body of type `application/json`.
   */
  updateOrderData(params: UpdateOrderData$Params, context?: HttpContext): Observable<OrderResponseDto> {
    return this.updateOrderData$Response(params, context).pipe(
      map((r: StrictHttpResponse<OrderResponseDto>): OrderResponseDto => r.body)
    );
  }

  /** Path part for operation `handleScanOrder()` */
  static readonly HandleScanOrderPath = '/v1/orders/scan';

  /**
   * This method provides access to the full `HttpResponse`, allowing access to response headers.
   * To access only the response body, use `handleScanOrder()` instead.
   *
   * This method sends `application/json` and handles request body of type `application/json`.
   */
  handleScanOrder$Response(params: HandleScanOrder$Params, context?: HttpContext): Observable<StrictHttpResponse<void>> {
    return handleScanOrder(this.http, this.rootUrl, params, context);
  }

  /**
   * This method provides access only to the response body.
   * To access the full response (for headers, for example), `handleScanOrder$Response()` instead.
   *
   * This method sends `application/json` and handles request body of type `application/json`.
   */
  handleScanOrder(params: HandleScanOrder$Params, context?: HttpContext): Observable<void> {
    return this.handleScanOrder$Response(params, context).pipe(
      map((r: StrictHttpResponse<void>): void => r.body)
    );
  }

  /** Path part for operation `handlePostponeOrder()` */
  static readonly HandlePostponeOrderPath = '/v1/orders/scan/postpone/{orderId}';

  /**
   * This method provides access to the full `HttpResponse`, allowing access to response headers.
   * To access only the response body, use `handlePostponeOrder()` instead.
   *
   * This method doesn't expect any request body.
   */
  handlePostponeOrder$Response(params: HandlePostponeOrder$Params, context?: HttpContext): Observable<StrictHttpResponse<void>> {
    return handlePostponeOrder(this.http, this.rootUrl, params, context);
  }

  /**
   * This method provides access only to the response body.
   * To access the full response (for headers, for example), `handlePostponeOrder$Response()` instead.
   *
   * This method doesn't expect any request body.
   */
  handlePostponeOrder(params: HandlePostponeOrder$Params, context?: HttpContext): Observable<void> {
    return this.handlePostponeOrder$Response(params, context).pipe(
      map((r: StrictHttpResponse<void>): void => r.body)
    );
  }

  /** Path part for operation `handleRescanFile()` */
  static readonly HandleRescanFilePath = '/v1/orders/rescan/{orderId}';

  /**
   * This method provides access to the full `HttpResponse`, allowing access to response headers.
   * To access only the response body, use `handleRescanFile()` instead.
   *
   * This method doesn't expect any request body.
   */
  handleRescanFile$Response(params: HandleRescanFile$Params, context?: HttpContext): Observable<StrictHttpResponse<void>> {
    return handleRescanFile(this.http, this.rootUrl, params, context);
  }

  /**
   * This method provides access only to the response body.
   * To access the full response (for headers, for example), `handleRescanFile$Response()` instead.
   *
   * This method doesn't expect any request body.
   */
  handleRescanFile(params: HandleRescanFile$Params, context?: HttpContext): Observable<void> {
    return this.handleRescanFile$Response(params, context).pipe(
      map((r: StrictHttpResponse<void>): void => r.body)
    );
  }

  /** Path part for operation `handleCancelRescanFile()` */
  static readonly HandleCancelRescanFilePath = '/v1/orders/rescan/cancel/{orderId}';

  /**
   * This method provides access to the full `HttpResponse`, allowing access to response headers.
   * To access only the response body, use `handleCancelRescanFile()` instead.
   *
   * This method doesn't expect any request body.
   */
  handleCancelRescanFile$Response(params: HandleCancelRescanFile$Params, context?: HttpContext): Observable<StrictHttpResponse<void>> {
    return handleCancelRescanFile(this.http, this.rootUrl, params, context);
  }

  /**
   * This method provides access only to the response body.
   * To access the full response (for headers, for example), `handleCancelRescanFile$Response()` instead.
   *
   * This method doesn't expect any request body.
   */
  handleCancelRescanFile(params: HandleCancelRescanFile$Params, context?: HttpContext): Observable<void> {
    return this.handleCancelRescanFile$Response(params, context).pipe(
      map((r: StrictHttpResponse<void>): void => r.body)
    );
  }

  /** Path part for operation `handleRejectOrder()` */
  static readonly HandleRejectOrderPath = '/v1/orders/reject/{orderId}';

  /**
   * This method provides access to the full `HttpResponse`, allowing access to response headers.
   * To access only the response body, use `handleRejectOrder()` instead.
   *
   * This method sends `application/json` and handles request body of type `application/json`.
   */
  handleRejectOrder$Response(params: HandleRejectOrder$Params, context?: HttpContext): Observable<StrictHttpResponse<void>> {
    return handleRejectOrder(this.http, this.rootUrl, params, context);
  }

  /**
   * This method provides access only to the response body.
   * To access the full response (for headers, for example), `handleRejectOrder$Response()` instead.
   *
   * This method sends `application/json` and handles request body of type `application/json`.
   */
  handleRejectOrder(params: HandleRejectOrder$Params, context?: HttpContext): Observable<void> {
    return this.handleRejectOrder$Response(params, context).pipe(
      map((r: StrictHttpResponse<void>): void => r.body)
    );
  }

  /** Path part for operation `resendEmailLinkPdf()` */
  static readonly ResendEmailLinkPdfPath = '/v1/orders/pdf/resendlink/{orderId}';

  /**
   * This method provides access to the full `HttpResponse`, allowing access to response headers.
   * To access only the response body, use `resendEmailLinkPdf()` instead.
   *
   * This method doesn't expect any request body.
   */
  resendEmailLinkPdf$Response(params: ResendEmailLinkPdf$Params, context?: HttpContext): Observable<StrictHttpResponse<{
}>> {
    return resendEmailLinkPdf(this.http, this.rootUrl, params, context);
  }

  /**
   * This method provides access only to the response body.
   * To access the full response (for headers, for example), `resendEmailLinkPdf$Response()` instead.
   *
   * This method doesn't expect any request body.
   */
  resendEmailLinkPdf(params: ResendEmailLinkPdf$Params, context?: HttpContext): Observable<{
}> {
    return this.resendEmailLinkPdf$Response(params, context).pipe(
      map((r: StrictHttpResponse<{
}>): {
} => r.body)
    );
  }

  /** Path part for operation `getChairsOrderBySignatureContaining()` */
  static readonly GetChairsOrderBySignatureContainingPath = '/v1/orders/signature';

  /**
   * This method provides access to the full `HttpResponse`, allowing access to response headers.
   * To access only the response body, use `getChairsOrderBySignatureContaining()` instead.
   *
   * This method doesn't expect any request body.
   */
  getChairsOrderBySignatureContaining$Response(params: GetChairsOrderBySignatureContaining$Params, context?: HttpContext): Observable<StrictHttpResponse<FaudokResponsePageOrderResponseDto>> {
    return getChairsOrderBySignatureContaining(this.http, this.rootUrl, params, context);
  }

  /**
   * This method provides access only to the response body.
   * To access the full response (for headers, for example), `getChairsOrderBySignatureContaining$Response()` instead.
   *
   * This method doesn't expect any request body.
   */
  getChairsOrderBySignatureContaining(params: GetChairsOrderBySignatureContaining$Params, context?: HttpContext): Observable<FaudokResponsePageOrderResponseDto> {
    return this.getChairsOrderBySignatureContaining$Response(params, context).pipe(
      map((r: StrictHttpResponse<FaudokResponsePageOrderResponseDto>): FaudokResponsePageOrderResponseDto => r.body)
    );
  }

  /** Path part for operation `getOrderPdf()` */
  static readonly GetOrderPdfPath = '/v1/orders/pdf/{orderId}';

  /**
   * This method provides access to the full `HttpResponse`, allowing access to response headers.
   * To access only the response body, use `getOrderPdf()` instead.
   *
   * This method doesn't expect any request body.
   */
  getOrderPdf$Response(params: GetOrderPdf$Params, context?: HttpContext): Observable<StrictHttpResponse<Blob>> {
    return getOrderPdf(this.http, this.rootUrl, params, context);
  }

  /**
   * This method provides access only to the response body.
   * To access the full response (for headers, for example), `getOrderPdf$Response()` instead.
   *
   * This method doesn't expect any request body.
   */
  getOrderPdf(params: GetOrderPdf$Params, context?: HttpContext): Observable<Blob> {
    return this.getOrderPdf$Response(params, context).pipe(
      map((r: StrictHttpResponse<Blob>): Blob => r.body)
    );
  }

  /** Path part for operation `getChairsInprogressOrders()` */
  static readonly GetChairsInprogressOrdersPath = '/v1/orders/inprogress/chair';

  /**
   * This method provides access to the full `HttpResponse`, allowing access to response headers.
   * To access only the response body, use `getChairsInprogressOrders()` instead.
   *
   * This method doesn't expect any request body.
   */
  getChairsInprogressOrders$Response(params?: GetChairsInprogressOrders$Params, context?: HttpContext): Observable<StrictHttpResponse<FaudokResponsePageOrderResponseDto>> {
    return getChairsInprogressOrders(this.http, this.rootUrl, params, context);
  }

  /**
   * This method provides access only to the response body.
   * To access the full response (for headers, for example), `getChairsInprogressOrders$Response()` instead.
   *
   * This method doesn't expect any request body.
   */
  getChairsInprogressOrders(params?: GetChairsInprogressOrders$Params, context?: HttpContext): Observable<FaudokResponsePageOrderResponseDto> {
    return this.getChairsInprogressOrders$Response(params, context).pipe(
      map((r: StrictHttpResponse<FaudokResponsePageOrderResponseDto>): FaudokResponsePageOrderResponseDto => r.body)
    );
  }

  /** Path part for operation `getChairsOrderByIdContaining()` */
  static readonly GetChairsOrderByIdContainingPath = '/v1/orders/id';

  /**
   * This method provides access to the full `HttpResponse`, allowing access to response headers.
   * To access only the response body, use `getChairsOrderByIdContaining()` instead.
   *
   * This method doesn't expect any request body.
   */
  getChairsOrderByIdContaining$Response(params: GetChairsOrderByIdContaining$Params, context?: HttpContext): Observable<StrictHttpResponse<FaudokResponsePageOrderResponseDto>> {
    return getChairsOrderByIdContaining(this.http, this.rootUrl, params, context);
  }

  /**
   * This method provides access only to the response body.
   * To access the full response (for headers, for example), `getChairsOrderByIdContaining$Response()` instead.
   *
   * This method doesn't expect any request body.
   */
  getChairsOrderByIdContaining(params: GetChairsOrderByIdContaining$Params, context?: HttpContext): Observable<FaudokResponsePageOrderResponseDto> {
    return this.getChairsOrderByIdContaining$Response(params, context).pipe(
      map((r: StrictHttpResponse<FaudokResponsePageOrderResponseDto>): FaudokResponsePageOrderResponseDto => r.body)
    );
  }

  /** Path part for operation `downloadFile()` */
  static readonly DownloadFilePath = '/v1/orders/files/{fileName}';

  /**
   * This method provides access to the full `HttpResponse`, allowing access to response headers.
   * To access only the response body, use `downloadFile()` instead.
   *
   * This method doesn't expect any request body.
   */
  downloadFile$Response(params: DownloadFile$Params, context?: HttpContext): Observable<StrictHttpResponse<Blob>> {
    return downloadFile(this.http, this.rootUrl, params, context);
  }

  /**
   * This method provides access only to the response body.
   * To access the full response (for headers, for example), `downloadFile$Response()` instead.
   *
   * This method doesn't expect any request body.
   */
  downloadFile(params: DownloadFile$Params, context?: HttpContext): Observable<Blob> {
    return this.downloadFile$Response(params, context).pipe(
      map((r: StrictHttpResponse<Blob>): Blob => r.body)
    );
  }

  /** Path part for operation `getChairsOrderByClientEmailContaining()` */
  static readonly GetChairsOrderByClientEmailContainingPath = '/v1/orders/email';

  /**
   * This method provides access to the full `HttpResponse`, allowing access to response headers.
   * To access only the response body, use `getChairsOrderByClientEmailContaining()` instead.
   *
   * This method doesn't expect any request body.
   */
  getChairsOrderByClientEmailContaining$Response(params: GetChairsOrderByClientEmailContaining$Params, context?: HttpContext): Observable<StrictHttpResponse<FaudokResponsePageOrderResponseDto>> {
    return getChairsOrderByClientEmailContaining(this.http, this.rootUrl, params, context);
  }

  /**
   * This method provides access only to the response body.
   * To access the full response (for headers, for example), `getChairsOrderByClientEmailContaining$Response()` instead.
   *
   * This method doesn't expect any request body.
   */
  getChairsOrderByClientEmailContaining(params: GetChairsOrderByClientEmailContaining$Params, context?: HttpContext): Observable<FaudokResponsePageOrderResponseDto> {
    return this.getChairsOrderByClientEmailContaining$Response(params, context).pipe(
      map((r: StrictHttpResponse<FaudokResponsePageOrderResponseDto>): FaudokResponsePageOrderResponseDto => r.body)
    );
  }

  /** Path part for operation `getChairsAvailableOrders()` */
  static readonly GetChairsAvailableOrdersPath = '/v1/orders/available/chair';

  /**
   * This method provides access to the full `HttpResponse`, allowing access to response headers.
   * To access only the response body, use `getChairsAvailableOrders()` instead.
   *
   * This method doesn't expect any request body.
   */
  getChairsAvailableOrders$Response(params?: GetChairsAvailableOrders$Params, context?: HttpContext): Observable<StrictHttpResponse<FaudokResponsePageOrderResponseDto>> {
    return getChairsAvailableOrders(this.http, this.rootUrl, params, context);
  }

  /**
   * This method provides access only to the response body.
   * To access the full response (for headers, for example), `getChairsAvailableOrders$Response()` instead.
   *
   * This method doesn't expect any request body.
   */
  getChairsAvailableOrders(params?: GetChairsAvailableOrders$Params, context?: HttpContext): Observable<FaudokResponsePageOrderResponseDto> {
    return this.getChairsAvailableOrders$Response(params, context).pipe(
      map((r: StrictHttpResponse<FaudokResponsePageOrderResponseDto>): FaudokResponsePageOrderResponseDto => r.body)
    );
  }

  /** Path part for operation `getChairsArchivedOrders()` */
  static readonly GetChairsArchivedOrdersPath = '/v1/orders/archived/chair';

  /**
   * This method provides access to the full `HttpResponse`, allowing access to response headers.
   * To access only the response body, use `getChairsArchivedOrders()` instead.
   *
   * This method doesn't expect any request body.
   */
  getChairsArchivedOrders$Response(params?: GetChairsArchivedOrders$Params, context?: HttpContext): Observable<StrictHttpResponse<FaudokResponsePageOrderResponseDto>> {
    return getChairsArchivedOrders(this.http, this.rootUrl, params, context);
  }

  /**
   * This method provides access only to the response body.
   * To access the full response (for headers, for example), `getChairsArchivedOrders$Response()` instead.
   *
   * This method doesn't expect any request body.
   */
  getChairsArchivedOrders(params?: GetChairsArchivedOrders$Params, context?: HttpContext): Observable<FaudokResponsePageOrderResponseDto> {
    return this.getChairsArchivedOrders$Response(params, context).pipe(
      map((r: StrictHttpResponse<FaudokResponsePageOrderResponseDto>): FaudokResponsePageOrderResponseDto => r.body)
    );
  }

}
